ctdb-scripts: Don't remove temporary files before use
[obnox/samba/samba-obnox.git] / ctdb / config / functions
index 0679938f0241d0487227e3b092be8c7dde7c9ecd..b41337ffbf7040c6aab6e9cc412a4bf810f8158e 100755 (executable)
@@ -2,21 +2,49 @@
 
 # utility functions for ctdb event scripts
 
-PATH=/bin:/usr/bin:/usr/sbin:/sbin:$PATH
+if [ -z "$CTDB_BASE" ] ; then
+    echo 'CTDB_BASE unset in CTDB functions file'
+    exit 1
+fi
 
-[ -z "$CTDB_VARDIR" ] && {
-    if [ -d "/var/lib/ctdb" ] ; then
-       export CTDB_VARDIR="/var/lib/ctdb"
-    else
-       export CTDB_VARDIR="/var/ctdb"
-    fi
-}
-[ -z "$CTDB_ETCDIR" ] && {
-    export CTDB_ETCDIR="/etc"
-}
+CTDB_VARDIR="/usr/local/var/lib/ctdb"
+ctdb_rundir="/usr/local/var/run/ctdb"
+
+# Only (and always) override these variables in test code
+
+if [ -z "$CTDB_SCRIPT_VARDIR" ] ; then
+    CTDB_SCRIPT_VARDIR="/usr/local/var/lib/ctdb/state"
+fi
+
+if [ -z "$CTDB_SYS_ETCDIR" ] ; then
+    CTDB_SYS_ETCDIR="/etc"
+fi
 
 #######################################
 # pull in a system config file, if any
+
+rewrite_ctdb_options ()
+{
+    case "$CTDB_DBDIR" in
+       tmpfs|tmpfs:*)
+           _opts_defaults="mode=700"
+           # Get any extra options specified after colon
+           if [ "$CTDB_DBDIR" = "tmpfs" ] ; then
+               _opts=""
+           else
+               _opts="${CTDB_DBDIR#tmpfs:}"
+           fi
+           # This is an internal variable, only used by ctdbd_wrapper.
+           # It is OK to repeat mount options - last value wins
+           CTDB_DBDIR_TMPFS_OPTIONS="${_opts_defaults}${_opts:+,}${_opts}"
+
+           CTDB_DBDIR="${ctdb_rundir}/CTDB_DBDIR"
+           ;;
+       *)
+           CTDB_DBDIR_TMPFS_OPTIONS=""
+    esac
+}
+
 _loadconfig() {
 
     if [ -z "$1" ] ; then
@@ -35,13 +63,21 @@ _loadconfig() {
        return
     fi
 
-    if [ -f $CTDB_ETCDIR/sysconfig/$1 ]; then
-       . $CTDB_ETCDIR/sysconfig/$1
-    elif [ -f $CTDB_ETCDIR/default/$1 ]; then
-       . $CTDB_ETCDIR/default/$1
+    if [ -f $CTDB_SYS_ETCDIR/sysconfig/$1 ]; then
+       . $CTDB_SYS_ETCDIR/sysconfig/$1
+    elif [ -f $CTDB_SYS_ETCDIR/default/$1 ]; then
+       . $CTDB_SYS_ETCDIR/default/$1
     elif [ -f $CTDB_BASE/sysconfig/$1 ]; then
        . $CTDB_BASE/sysconfig/$1
     fi
+
+    if [ "$1" = "ctdb" ] ; then
+       _config="${CTDB_BASE}/ctdbd.conf"
+       if [ -r "$_config" ] ; then
+           . "$_config"
+       fi
+       rewrite_ctdb_options
+    fi
 }
 
 loadconfig () {
@@ -60,9 +96,13 @@ debug ()
        # here document.
        if [ -n "$1" ] ; then
            echo "DEBUG: $*"
-       elif ! tty -s ; then
+       else
            sed -e 's@^@DEBUG: @'
        fi
+    else
+       if [ -z "$1" ] ; then
+           cat >/dev/null
+       fi
     fi
 }
 
@@ -81,25 +121,27 @@ script_log ()
 {
     _tag="$1" ; shift
 
-    _using_syslog=false
-    if [ "$CTDB_SYSLOG" = "yes" -o -z "$CTDB_LOGFILE" ] ; then
-       _using_syslog=true
-    fi
-    case "$CTDB_OPTIONS" in
-       *--syslog*) _using_syslog=true ;;
-    esac
-
-    if $_using_syslog ; then
-       logger -t "ctdbd: ${_tag}" $*
-    else
-       {
-           if [ -n "$*" ] ; then
-               echo "$*"
+    case "$CTDB_LOGGING" in
+       file:*|"")
+           if [ -n "$CTDB_LOGGING" ] ; then
+               _file="${CTDB_LOGGING#file:}"
            else
-               cat
+               _file="/usr/local/var/log/log.ctdb"
            fi
-       } >>"${CTDB_LOGFILE:-/var/log/log.ctdb}"
-    fi
+           {
+               if [ -n "$*" ] ; then
+                   echo "$*"
+               else
+                   cat
+               fi
+           } >>"$_file"
+           ;;
+       *)
+           # Handle all syslog:* variants here too.  There's no tool to do
+           # the lossy things, so just use logger.
+           logger -t "ctdbd: ${_tag}" $*
+           ;;
+    esac
 }
 
 # When things are run in the background in an eventscript then logging
@@ -136,9 +178,10 @@ ctdb_check_args ()
 
 ##############################################################
 # determine on what type of system (init style) we are running
-detect_init_style() {
+detect_init_style()
+{
     # only do detection if not already set:
-    test "x$CTDB_INIT_STYLE" != "x" && return
+    [ -z "$CTDB_INIT_STYLE" ] || return
 
     if [ -x /sbin/startproc ]; then
         CTDB_INIT_STYLE="suse"
@@ -163,10 +206,12 @@ _service ()
 
   if [ -x /sbin/service ]; then
       $_nice /sbin/service "$_service_name" "$_op"
-  elif [ -x $CTDB_ETCDIR/init.d/$_service_name ]; then
-      $_nice $CTDB_ETCDIR/init.d/$_service_name "$_op"
-  elif [ -x $CTDB_ETCDIR/rc.d/init.d/$_service_name ]; then
-      $_nice $CTDB_ETCDIR/rc.d/init.d/$_service_name "$_op"
+  elif [ -x /usr/sbin/service ]; then
+      $_nice /usr/sbin/service "$_service_name" "$_op"
+  elif [ -x $CTDB_SYS_ETCDIR/init.d/$_service_name ]; then
+      $_nice $CTDB_SYS_ETCDIR/init.d/$_service_name "$_op"
+  elif [ -x $CTDB_SYS_ETCDIR/rc.d/init.d/$_service_name ]; then
+      $_nice $CTDB_SYS_ETCDIR/rc.d/init.d/$_service_name "$_op"
   fi
 }
 
@@ -184,6 +229,20 @@ nice_service()
     _service "$@"
 }
 
+######################################################
+# Cached retrieval of PNN from local node.  This never changes so why
+# open a client connection to the server each time this is needed?
+# This sets $pnn - this avoid an unnecessary subprocess.
+ctdb_get_pnn ()
+{
+    _pnn_file="${CTDB_SCRIPT_VARDIR}/my-pnn"
+    if [ ! -f "$_pnn_file" ] ; then
+       ctdb pnn | sed -e 's@.*:@@' >"$_pnn_file"
+    fi
+
+    read pnn <"$_pnn_file"
+}
+
 ######################################################
 # wrapper around /proc/ settings to allow them to be hooked
 # for testing
@@ -193,6 +252,13 @@ set_proc ()
     echo "$2" >"/proc/$1"
 }
 
+set_proc_maybe ()
+{
+    if [ -w "/proc/$1" ] ; then
+       set_proc "$1" "$2"
+    fi
+}
+
 ######################################################
 # wrapper around getting file contents from /proc/ to allow
 # this to be hooked for testing
@@ -203,202 +269,24 @@ get_proc ()
 }
 
 ######################################################
-# Check that an RPC service is healthy -
-# this includes allowing a certain number of failures
-# before marking the NFS service unhealthy.
-#
-# usage: nfs_check_rpc_service SERVICE_NAME [ triple ...]
-#
-# each triple is a set of 3 arguments: an operator, a 
-# fail count limit and an action string.
-#
-# For example:
-#
-#      nfs_check_rpc_service "lockd" \
-#          -ge 15 "verbose restart unhealthy" \
-#          -eq 10 "restart:bs"
-#
-# says that if lockd is down for 15 iterations then do
-# a verbose restart of lockd and mark the node unhealthy.
-# Before this, after 10 iterations of failure, the
-# service is restarted silently in the background.
-# Order is important: the number of failures need to be
-# specified in reverse order because processing stops
-# after the first condition that is true.
-######################################################
-nfs_check_rpc_service ()
+# Print up to $_max kernel stack traces for processes named $_program
+program_stack_traces ()
 {
-    _prog_name="$1" ; shift
-
-    if _nfs_check_rpc_common "$_prog_name" ; then
-       return
-    fi
+    _prog="$1"
+    _max="${2:-1}"
 
-    while [ -n "$3" ] ; do
-       if _nfs_check_rpc_action "$1" "$2" "$3" ; then
-           break
-       fi
-       shift 3
-    done
-}
+    _count=1
+    for _pid in $(pidof "$_prog") ; do
+       [ $_count -le $_max ] || break
 
-# The new way of doing things...
-nfs_check_rpc_services ()
-{
-    # Files must end with .check - avoids editor backups, RPM fu, ...
-    for _f in "${CTDB_BASE}/nfs-rpc-checks.d/"[0-9][0-9].*.check ; do
-       _t="${_f%.check}"
-       _prog_name="${_t##*/[0-9][0-9].}"
-
-       if _nfs_check_rpc_common "$_prog_name" ; then
-           # This RPC service is up, check next service...
-           continue
+       # Do this first to avoid racing with process exit
+       _stack=$(get_proc "${_pid}/stack" 2>/dev/null)
+       if [ -n "$_stack" ] ; then
+           echo "Stack trace for ${_prog}[${_pid}]:"
+           echo "$_stack"
+           _count=$(($_count + 1))
        fi
-
-       # Check each line in the file in turn until one of the limit
-       # checks is hit...
-       while read _cmp _lim _rest ; do
-           # Skip comments
-           case "$_cmp" in
-               \#*) continue ;;
-           esac
-
-           if _nfs_check_rpc_action "$_cmp" "$_lim" "$_rest" ; then
-               # Limit was hit on this line, no further checking...
-               break
-           fi
-       done <"$_f"
-    done
-}
-
-_nfs_check_rpc_common ()
-{
-    _prog_name="$1"
-
-    # Some platforms don't have separate programs for all services.
-    case "$_prog_name" in
-       statd)
-           which "rpc.${_prog_name}" >/dev/null 2>&1 || return 0
-    esac
-
-    _version=1
-    _rpc_prog="$_prog_name"
-    _restart=""
-    _opts=""
-    case "$_prog_name" in
-       nfsd)
-           _rpc_prog=nfs
-           _version=3
-           _restart="echo 'Trying to restart NFS service'"
-           _restart="${_restart}; startstop_nfs restart"
-           ;;
-       mountd)
-           _opts="${MOUNTD_PORT:+ -p }${MOUNTD_PORT}"
-           ;;
-       rquotad)
-           _opts="${RQUOTAD_PORT:+ -p }${RQUOTAD_PORT}"
-           ;;
-       lockd)
-           _rpc_prog=nlockmgr
-           _version=4
-           _restart="echo 'Trying to restart lock manager service'"
-           _restart="${_restart}; startstop_nfslock restart"
-           ;;
-       statd)
-           _rpc_prog=status
-           _opts="${STATD_HOSTNAME:+ -n }${STATD_HOSTNAME}"
-           _opts="${_opts}${STATD_PORT:+ -p }${STATD_PORT}"
-           _opts="${_opts}${STATD_OUTGOING_PORT:+ -o }${STATD_OUTGOING_PORT}"
-           ;;
-       *)
-           echo "Internal error: unknown RPC program \"$_prog_name\"."
-           exit 1
-    esac
-
-    _service_name="nfs_${_prog_name}"
-
-    if ctdb_check_rpc "$_rpc_prog" $_version >/dev/null ; then
-       ctdb_counter_init "$_service_name"
-       return 0
-    fi
-
-    ctdb_counter_incr "$_service_name"
-
-    return 1
-}
-
-_nfs_check_rpc_action ()
-{
-    _cmp="$1"
-    _limit="$2"
-    _actions="$3"
-
-    if ctdb_check_counter "quiet" "$_cmp" "$_limit" "$_service_name" ; then
-       return 1
-    fi
-
-    for _action in $_actions ; do
-       case "$_action" in
-           verbose)
-               echo "$ctdb_check_rpc_out"
-               ;;
-           restart|restart:*)
-               # No explicit command specified, construct rpc command.
-               if [ -z "$_restart" ] ; then
-                   _p="rpc.${_prog_name}"
-                   _restart="echo 'Trying to restart $_prog_name [${_p}${_opts}]'"
-                   _restart="${_restart}; killall -q -9 $_p"
-                   _restart="${_restart}; $_p $_opts"
-               fi
-
-               # Process restart flags...
-               _flags="${_action#restart:}"
-               # There may not have been a colon...
-               [ "$_flags" != "$_action" ] || _flags=""
-               # q=quiet - everything to /dev/null
-               if [ "${_flags#*q}" != "$_flags" ] ; then
-                   _restart="{ ${_restart} ; } >/dev/null 2>&1"
-               fi
-               # s=stealthy - last command to /dev/null
-               if [ "${_flags#*s}" != "$_flags" ] ; then
-                   _restart="${_restart} >/dev/null 2>&1"
-               fi
-               # b=background - the whole thing, easy and reliable
-               if [ "${_flags#*b}" != "$_flags" ] ; then
-                   _restart="{ ${_restart} ; } &"
-               fi
-
-               # Do it!
-               eval "${_restart}"
-               ;;
-           unhealthy)
-               exit 1
-               ;;
-           *)
-               echo "Internal error: unknown action \"$_action\"."
-               exit 1
-       esac
     done
-
-    return 0
-}
-
-######################################################
-# check that a rpc server is registered with portmap
-# and responding to requests
-# usage: ctdb_check_rpc SERVICE_NAME VERSION
-######################################################
-ctdb_check_rpc ()
-{
-    progname="$1"
-    version="$2"
-
-    if ! ctdb_check_rpc_out=$(rpcinfo -u localhost $progname $version 2>&1) ; then
-       ctdb_check_rpc_out="ERROR: $progname failed RPC check:
-$ctdb_check_rpc_out"
-       echo "$ctdb_check_rpc_out"
-       return 1
-    fi
 }
 
 ######################################################
@@ -450,7 +338,8 @@ ctdb_check_directories()
 _ctdb_check_tcp_common ()
 {
     assert_service_name
-    _ctdb_service_started_file="$ctdb_fail_dir/$service_name.started"
+    _d="${CTDB_SCRIPT_VARDIR}/failcount"
+    _ctdb_service_started_file="${_d}/${service_name}.started"
 }
 
 ctdb_check_tcp_init ()
@@ -460,6 +349,8 @@ ctdb_check_tcp_init ()
     touch "$_ctdb_service_started_file"
 }
 
+# Check whether something is listening on all of the given TCP ports
+# using the "ctdb checktcpport" command.
 ctdb_check_tcp_ports()
 {
     if [ -z "$1" ] ; then
@@ -467,129 +358,20 @@ ctdb_check_tcp_ports()
        exit 1
     fi
 
-    # Set default value for CTDB_TCP_PORT_CHECKS if unset.
-    # If any of these defaults are unsupported then this variable can
-    # be overridden in /etc/sysconfig/ctdb or via a file in
-    # /etc/ctdb/rc.local.d/.
-    : ${CTDB_TCP_PORT_CHECKERS:=ctdb nmap netstat}
-
-    for _c in $CTDB_TCP_PORT_CHECKERS ; do
-       ctdb_check_tcp_ports_$_c "$@"
-       case "$?" in
+    for _p ; do  # process each function argument (port)
+       _cmd="ctdb checktcpport $_p"
+       _out=$($_cmd 2>&1)
+       _ret=$?
+       case "$_ret" in
            0)
-               _ctdb_check_tcp_common
-               rm -f "$_ctdb_service_started_file"
-               return 0
-               ;;
-           1)
                _ctdb_check_tcp_common
                if [ ! -f "$_ctdb_service_started_file" ] ; then
                    echo "ERROR: $service_name tcp port $_p is not responding"
-                   debug <<EOF
-$ctdb_check_tcp_ports_debug
-EOF
+                   debug "\"ctdb checktcpport $_p\" was able to bind to port"
                else
                    echo "INFO: $service_name tcp port $_p is not responding"
                fi
 
-               return 1
-               ;;
-           127)
-               debug <<EOF
-ctdb_check_ports - checker $_c not implemented
-output from checker was:
-$ctdb_check_tcp_ports_debug
-EOF
-               ;;
-           *)
-               
-       esac
-    done
-
-    echo "INTERNAL ERROR: ctdb_check_ports - no working checkers in CTDB_TCP_PORT_CHECKERS=\"$CTDB_TCP_PORT_CHECKERS\""
-
-    return 127
-}
-
-ctdb_check_tcp_ports_netstat ()
-{
-    _cmd='netstat -l -t -n'
-    _ns=$($_cmd 2>&1)
-    if [ $? -eq 127 ] ; then
-       # netstat probably not installed - unlikely?
-       ctdb_check_tcp_ports_debug="$_ns"
-       return 127
-    fi
-
-    for _p ; do  # process each function argument (port)
-       for _a in '0\.0\.0\.0' '::' ; do
-           _pat="[[:space:]]${_a}:${_p}[[:space:]]+[^[:space:]]+[[:space:]]+LISTEN"
-           if echo "$_ns" | grep -E -q "$_pat" ; then
-               # We matched the port, so process next port
-               continue 2
-           fi
-       done
-
-       # We didn't match the port, so flag an error.
-       ctdb_check_tcp_ports_debug="$_cmd shows this output:
-$_ns"
-       return 1
-    done
-
-    return 0
-}
-
-ctdb_check_tcp_ports_nmap ()
-{
-    # nmap wants a comma-separated list of ports
-    _ports=""
-    for _p ; do
-       _ports="${_ports}${_ports:+,}${_p}"
-    done
-
-    _cmd="nmap -n -oG - -PS 127.0.0.1 -p $_ports"
-
-    _nmap_out=$($_cmd 2>&1)
-    if [ $? -eq 127 ] ; then
-       # nmap probably not installed
-       ctdb_check_tcp_ports_debug="$_nmap_out"
-       return 127
-    fi
-
-    # get the port-related output
-    _port_info=$(echo "$_nmap_out" | sed -n -r -e 's@^.*Ports:[[:space:]]@@p')
-
-    for _p ; do
-       # looking for something like this:
-       #  445/open/tcp//microsoft-ds///
-       # possibly followed by a comma
-       _t="$_p/open/tcp//"
-       case "$_port_info" in
-           # The info we're after must be either at the beginning of
-           # the string or it must follow a space.
-            $_t*|*\ $_t*) : ;;
-           *)
-               # Nope, flag an error...
-               ctdb_check_tcp_ports_debug="$_cmd shows this output:
-$_nmap_out"
-               return 1
-       esac
-    done
-
-    return 0
-}
-
-# Use the new "ctdb checktcpport" command to check the port.
-# This is very cheap.
-ctdb_check_tcp_ports_ctdb ()
-{
-    for _p ; do  # process each function argument (port)
-       _cmd="ctdb checktcpport $_p"
-       _out=$($_cmd 2>&1)
-       _ret=$?
-       case "$_ret" in
-           0)
-               ctdb_check_tcp_ports_debug="\"$_cmd\" was able to bind to port"
                return 1
                ;;
            98)
@@ -597,13 +379,18 @@ ctdb_check_tcp_ports_ctdb ()
                continue
                ;;
            *)
-               ctdb_check_tcp_ports_debug="$_cmd (exited with $_ret) with output:
+               echo "ERROR: unexpected error running \"ctdb checktcpport\""
+               debug <<EOF
+ctdb checktcpport (exited with $_ret) with output:
 $_out"
-               # assume not implemented
-               return 127
+EOF
+               return $_ret
        esac
     done
 
+    # All ports listening
+    _ctdb_check_tcp_common
+    rm -f "$_ctdb_service_started_file"
     return 0
 }
 
@@ -648,45 +435,51 @@ kill_tcp_connections ()
 
     get_tcp_connections_for_ip "$_ip" | {
        _killcount=0
-       _failed=false
-
-       while read dest src; do
-           echo "Killing TCP connection $src $dest"
-           ctdb killtcp $src $dest >/dev/null 2>&1 || _failed=true
-           _destport="${dest##*:}"
+       _connections=""
+       _nl="
+"
+       while read _dst _src; do
+           _destport="${_dst##*:}"
            __oneway=$_oneway
            case $_destport in
                # we only do one-way killtcp for CIFS
                139|445) __oneway=true ;;
            esac
+
+           echo "Killing TCP connection $_src $_dst"
+           _connections="${_connections}${_nl}${_src} ${_dst}"
            if ! $__oneway ; then
-               ctdb killtcp $dest $src >/dev/null 2>&1 || _failed=true
+               _connections="${_connections}${_nl}${_dst} ${_src}"
            fi
 
            _killcount=$(($_killcount + 1))
        done
 
-       if $_failed ; then
-           echo "Failed to send killtcp control"
-           return
-       fi
        if [ $_killcount -eq 0 ] ; then
            return
        fi
 
+       echo "$_connections" | ctdb killtcp || {
+           echo "Failed to send killtcp control"
+           return
+       }
+
        _count=0
        while : ; do
-           if [ -z "$(get_tcp_connections_for_ip $_ip)" ] ; then
+           _remaining=$(get_tcp_connections_for_ip $_ip | wc -l)
+
+           if [ $_remaining -eq 0 ] ; then
                echo "Killed $_killcount TCP connections to released IP $_ip"
                return
            fi
 
            _count=$(($_count + 1))
            if [ $_count -gt 3 ] ; then
-               echo "Timed out killing tcp connections for IP $_ip"
+               echo "Timed out killing tcp connections for IP $_ip ($_remaining remaining)"
                return
            fi
 
+           echo "Waiting for $_remaining connections to be killed for IP $_ip"
            sleep 1
        done
     }
@@ -736,266 +529,87 @@ get_tcp_connections_for_ip ()
 }
 
 ########################################################
-# start/stop the Ganesha nfs service
-########################################################
-startstop_ganesha()
-{
-    _service_name="nfs-ganesha-$CTDB_CLUSTER_FILESYSTEM_TYPE"
-    case "$1" in
-       start)
-           service "$_service_name" start
-           ;;
-       stop)
-           service "$_service_name" stop
-           ;;
-       restart)
-           service "$_service_name" restart
-           ;;
-    esac
-}
-
-########################################################
-# start/stop the nfs service on different platforms
-########################################################
-startstop_nfs() {
-       PLATFORM="unknown"
-       [ -x $CTDB_ETCDIR/init.d/nfsserver ] && {
-               PLATFORM="sles"
-       }
-       [ -x $CTDB_ETCDIR/init.d/nfslock ] && {
-               PLATFORM="rhel"
-       }
 
-       case $PLATFORM in
-       sles)
-               case $1 in
-               start)
-                       service nfsserver start
-                       ;;
-               stop)
-                       service nfsserver stop > /dev/null 2>&1
-                       ;;
-               restart)
-                       set_proc "fs/nfsd/threads" 0
-                       service nfsserver stop > /dev/null 2>&1
-                       pkill -9 nfsd
-                       nfs_dump_some_threads
-                       service nfsserver start
-                       ;;
-               esac
-               ;;
-       rhel)
-               case $1 in
-               start)
-                       service nfslock start
-                       service nfs start
-                       ;;
-               stop)
-                       service nfs stop
-                       service nfslock stop
-                       ;;
-               restart)
-                       set_proc "fs/nfsd/threads" 0
-                       service nfs stop > /dev/null 2>&1
-                       service nfslock stop > /dev/null 2>&1
-                       pkill -9 nfsd
-                       nfs_dump_some_threads
-                       service nfslock start
-                       service nfs start
-                       ;;
-               esac
-               ;;
-       *)
-               echo "Unknown platform. NFS is not supported with ctdb"
-               exit 1
-               ;;
-       esac
-}
-
-# Dump up to the configured number of nfsd thread backtraces.
-nfs_dump_some_threads ()
+add_ip_to_iface ()
 {
-    [ -n "$CTDB_NFS_DUMP_STUCK_THREADS" ] || return 0
+    _iface=$1
+    _ip=$2
+    _maskbits=$3
 
-    # Optimisation to avoid running an unnecessary pidof
-    [ $CTDB_NFS_DUMP_STUCK_THREADS -gt 0 ] || return 0
+    # Ensure interface is up
+    ip link set "$_iface" up || \
+       die "Failed to bringup interface $_iface"
 
-    _count=0
-    for _pid in $(pidof nfsd) ; do
-       [ $_count -le $CTDB_NFS_DUMP_STUCK_THREADS ] || break
+    # Only need to define broadcast for IPv4
+    case "$ip" in
+        *:*) _bcast=""      ;;
+       *)   _bcast="brd +" ;;
+    esac
 
-       # Do this first to avoid racing with thread exit
-       _stack=$(get_proc "${_pid}/stack" 2>/dev/null)
-       if [ -n "$_stack" ] ; then
-           echo "Stack trace for stuck nfsd thread [${_pid}]:"
-           echo "$_stack"
-           _count=$(($_count + 1))
-       fi
-    done
-}
+    ip addr add "$_ip/$_maskbits" $_bcast dev "$_iface" || {
+       echo "Failed to add $_ip/$_maskbits on dev $_iface"
+       return 1
+    }
 
-########################################################
-# start/stop the nfs lockmanager service on different platforms
-########################################################
-startstop_nfslock() {
-       PLATFORM="unknown"
-       [ -x $CTDB_ETCDIR/init.d/nfsserver ] && {
-               PLATFORM="sles"
-       }
-       [ -x $CTDB_ETCDIR/init.d/nfslock ] && {
-               PLATFORM="rhel"
-       }
+    # Wait 5 seconds for IPv6 addresses to stop being tentative...
+    if [ -z "$_bcast" ] ; then
+       for _x in $(seq 1 10) ; do
+           ip addr show to "${_ip}/128" | grep -q "tentative" || break
+           sleep 0.5
+       done
 
-       case $PLATFORM in
-       sles)
-               # for sles there is no service for lockmanager
-               # so we instead just shutdown/restart nfs
-               case $1 in
-               start)
-                       service nfsserver start
-                       ;;
-               stop)
-                       service nfsserver stop > /dev/null 2>&1
-                       ;;
-               restart)
-                       service nfsserver stop
-                       service nfsserver start
-                       ;;
-               esac
-               ;;
-       rhel)
-               case $1 in
-               start)
-                       service nfslock start
-                       ;;
-               stop)
-                       service nfslock stop > /dev/null 2>&1
-                       ;;
-               restart)
-                       service nfslock stop
-                       service nfslock start
-                       ;;
-               esac
+       # If the address was a duplicate then it won't be on the
+       # interface so flag an error.
+       _t=$(ip addr show to "${_ip}/128")
+       case "$_t" in
+           "")
+               echo "Failed to add $_ip/$_maskbits on dev $_iface"
+               return 1
                ;;
-       *)
-               echo "Unknown platform. NFS locking is not supported with ctdb"
-               exit 1
+           *tentative*|*dadfailed*)
+               echo "Failed to add $_ip/$_maskbits on dev $_iface"
+               ip addr del "$_ip/$_maskbits" dev "$_iface"
+               return 1
                ;;
        esac
-}
-
-# Periodically update the statd database
-nfs_statd_update ()
-{
-    _update_period="$1"
-
-    _statd_update_trigger="$service_state_dir/update-trigger"
-    [ -f "$_statd_update_trigger" ] || touch "$_statd_update_trigger"
-
-    _last_update=$(stat --printf="%Y" "$_statd_update_trigger")
-    _current_time=$(date +"%s")
-    if [ $(( $_current_time - $_last_update)) -ge $_update_period ] ; then
-       touch "$_statd_update_trigger"
-       $CTDB_BASE/statd-callout updatelocal &
-       $CTDB_BASE/statd-callout updateremote &
     fi
 }
 
-add_ip_to_iface()
-{
-    _iface=$1
-    _ip=$2
-    _maskbits=$3
-
-    _lockfile="${CTDB_VARDIR}/state/interface_modify_${_iface}.flock"
-    mkdir -p "${_lockfile%/*}" # dirname
-    [ -f "$_lockfile" ] || touch "$_lockfile"
-
-    (
-       # Note: use of return/exit/die() below only gets us out of the
-       # sub-shell, which is actually what we want.  That is, the
-       # function should just return non-zero.
-
-       flock --timeout 30 0 || \
-           die "add_ip_to_iface: unable to get lock for ${_iface}"
-
-       # Ensure interface is up
-       ip link set "$_iface" up || \
-           die "Failed to bringup interface $_iface"
-
-       ip addr add "$_ip/$_maskbits" brd + dev "$_iface" || \
-           die "Failed to add $_ip/$_maskbits on dev $_iface"
-    ) <"$_lockfile"
-
-    # Do nothing here - return above only gets us out of the subshell
-    # and doing anything here will affect the return code.
-}
-
 delete_ip_from_iface()
 {
     _iface=$1
     _ip=$2
     _maskbits=$3
 
-    _lockfile="${CTDB_VARDIR}/state/interface_modify_${_iface}.flock"
-    mkdir -p "${_lockfile%/*}" # dirname
-    [ -f "$_lockfile" ] || touch "$_lockfile"
-
-    (
-       # Note: use of return/exit/die() below only gets us out of the
-       # sub-shell, which is actually what we want.  That is, the
-       # function should just return non-zero.
-
-       flock --timeout 30 0 || \
-           die "delete_ip_from_iface: unable to get lock for ${_iface}"
-
-       _im="$_ip/$_maskbits"  # shorthand for readability
-
-       # "ip addr del" will delete all secondary IPs if this is the
-       # primary.  To work around this _very_ annoying behaviour we
-       # have to keep a record of the secondaries and re-add them
-       # afterwards.  Yuck!
-
-       _secondaries=""
-       if ip addr list dev "$_iface" primary | grep -Fq "inet $_im " ; then
-           _secondaries=$(ip addr list dev "$_iface" secondary | \
-               awk '$1 == "inet" { print $2 }')
-       fi
-
-       local _rc=0
-       ip addr del "$_im" dev "$_iface" || {
-           echo "Failed to del $_ip on dev $_iface"
-           _rc=1
-       }
-
-       if [ -n "$_secondaries" ] ; then
-           for _i in $_secondaries; do
-               if ip addr list dev "$_iface" | grep -Fq "inet $_i" ; then
-                   echo "Kept secondary $_i on dev $_iface"
-               else
-                   echo "Re-adding secondary address $_i to dev $_iface"
-                   ip addr add $_i brd + dev $_iface || {
-                       echo "Failed to re-add address $_i to dev $_iface"
-                       _rc=1
-                   }
-               fi
-           done
-       fi
+    # This could be set globally for all interfaces but it is probably
+    # better to avoid surprises, so limit it the interfaces where CTDB
+    # has public IP addresses.  There isn't anywhere else convenient
+    # to do this so just set it each time.  This is much cheaper than
+    # remembering and re-adding secondaries.
+    set_proc "sys/net/ipv4/conf/${_iface}/promote_secondaries" 1
 
-       return $_rc
-    ) <"$_lockfile"
-
-    # Do nothing here - return above only gets us out of the subshell
-    # and doing anything here will affect the return code.
+    ip addr del "$_ip/$_maskbits" dev "$_iface" || {
+       echo "Failed to del $_ip on dev $_iface"
+       return 1
+    }
 }
 
-# If the given IP is hosted then print 2 items: maskbits and iface 
+# If the given IP is hosted then print 2 items: maskbits and iface
 ip_maskbits_iface ()
 {
     _addr="$1"
 
-    ip addr show to "${_addr}/32" 2>/dev/null | \
-       awk '$1 == "inet" { print gensub(".*/", "", 1, $2), $NF }'
+    case "$_addr" in
+       *:*) _family="inet6" ; _bits=128 ;;
+       *)   _family="inet"  ; _bits=32  ;;
+    esac
+
+    ip addr show to "${_addr}/${_bits}" 2>/dev/null | \
+       awk -v family="${_family}" \
+           'NR == 1 { iface = $2; sub(":$", "", iface) ; \
+                      sub("@.*", "", iface) } \
+             $1 ~ /inet/ { mask = $2; sub(".*/", "", mask); \
+                           print mask, iface, family }'
 }
 
 drop_ip ()
@@ -1018,16 +632,17 @@ drop_all_public_ips ()
     done <"${CTDB_PUBLIC_ADDRESSES:-/dev/null}"
 }
 
+flush_route_cache ()
+{
+    set_proc_maybe sys/net/ipv4/route/flush 1
+    set_proc_maybe sys/net/ipv6/route/flush 1
+}
+
 ########################################################
-# some simple logic for counting events - per eventscript
-# usage: ctdb_counter_init
-#        ctdb_counter_incr
-#        ctdb_check_counter_limit <limit>
-# ctdb_check_counter_limit fails when count >= <limit>
-########################################################
+# Simple counters
 _ctdb_counter_common () {
     _service_name="${1:-${service_name:-${script_name}}}"
-    _counter_file="$ctdb_fail_dir/$_service_name"
+    _counter_file="${CTDB_SCRIPT_VARDIR}/failcount/${_service_name}"
     mkdir -p "${_counter_file%/*}" # dirname
 }
 ctdb_counter_init () {
@@ -1041,18 +656,32 @@ ctdb_counter_incr () {
     # unary counting!
     echo -n 1 >> "$_counter_file"
 }
+ctdb_counter_get () {
+    _ctdb_counter_common "$1"
+    # unary counting!
+    stat -c "%s" "$_counter_file" 2>/dev/null || echo 0
+}
 ctdb_check_counter () {
     _msg="${1:-error}"  # "error"  - anything else is silent on fail
     _op="${2:--ge}"  # an integer operator supported by test
     _limit="${3:-${service_fail_limit}}"
     shift 3
-    _ctdb_counter_common "$1"
 
-    # unary counting!
-    _size=$(stat -c "%s" "$_counter_file" 2>/dev/null || echo 0)
-    if [ $_size $_op $_limit ] ; then
+    _size=$(ctdb_counter_get "$1")
+
+    _hit=false
+    if [ "$_op" != "%" ] ; then
+       if [ $_size $_op $_limit ] ; then
+           _hit=true
+       fi
+    else
+       if [ $(($_size $_op $_limit)) -eq 0 ] ; then
+           _hit=true
+       fi
+    fi
+    if $_hit ; then
        if [ "$_msg" = "error" ] ; then
-           echo "ERROR: $_limit consecutive failures for $_service_name, marking node unhealthy"
+           echo "ERROR: $_size consecutive failures for $_service_name, marking node unhealthy"
            exit 1              
        else
            return 1
@@ -1062,12 +691,9 @@ ctdb_check_counter () {
 
 ########################################################
 
-ctdb_status_dir="$CTDB_VARDIR/status"
-ctdb_fail_dir="$CTDB_VARDIR/failcount"
-
 ctdb_setup_service_state_dir ()
 {
-    service_state_dir="$CTDB_VARDIR/state/${1:-${service_name}}"
+    service_state_dir="${CTDB_SCRIPT_VARDIR}/service_state/${1:-${service_name}}"
     mkdir -p "$service_state_dir" || {
        echo "Error creating state dir \"$service_state_dir\""
        exit 1
@@ -1077,17 +703,15 @@ ctdb_setup_service_state_dir ()
 ########################################################
 # Managed status history, for auto-start/stop
 
-ctdb_managed_dir="$CTDB_VARDIR/managed_history"
-
 _ctdb_managed_common ()
 {
-    _ctdb_managed_file="$ctdb_managed_dir/$service_name"
+    _ctdb_managed_file="${CTDB_SCRIPT_VARDIR}/managed_history/${service_name}"
 }
 
 ctdb_service_managed ()
 {
     _ctdb_managed_common
-    mkdir -p "$ctdb_managed_dir"
+    mkdir -p "${_ctdb_managed_file%/*}" # dirname
     touch "$_ctdb_managed_file"
 }
 
@@ -1103,49 +727,12 @@ is_ctdb_previously_managed_service ()
     [ -f "$_ctdb_managed_file" ]
 }
 
-########################################################
-# Check and set status
-
-log_status_cat ()
-{
-    echo "node is \"$1\", \"${script_name}\" reports problem: $(cat $2)"
-}
-
-ctdb_checkstatus ()
-{
-    if [ -r "$ctdb_status_dir/$script_name/unhealthy" ] ; then
-       log_status_cat "unhealthy" "$ctdb_status_dir/$script_name/unhealthy"
-       return 1
-    elif [ -r "$ctdb_status_dir/$script_name/banned" ] ; then
-       log_status_cat "banned" "$ctdb_status_dir/$script_name/banned"
-       return 2
-    else
-       return 0
-    fi
-}
-
-ctdb_setstatus ()
-{
-    d="$ctdb_status_dir/$script_name"
-    case "$1" in
-       unhealthy|banned)
-           mkdir -p "$d"
-           cat "$2" >"$d/$1"
-           ;;
-       *)
-           for i in "banned" "unhealthy" ; do
-               rm -f "$d/$i"
-           done
-           ;;
-    esac
-}
-
 ##################################################################
 # Reconfigure a service on demand
 
 _ctdb_service_reconfigure_common ()
 {
-    _d="$ctdb_status_dir/${service_name}"
+    _d="${CTDB_SCRIPT_VARDIR}/service_status/${service_name}"
     mkdir -p "$_d"
     _ctdb_service_reconfigure_flag="$_d/reconfigure"
 }
@@ -1182,7 +769,7 @@ service_reconfigure ()
     :
 }
 
-ctdb_reconfigure_try_lock ()
+ctdb_reconfigure_take_lock ()
 {
     _ctdb_service_reconfigure_common
     _lock="${_d}/reconfigure_lock"
@@ -1209,22 +796,30 @@ ctdb_reconfigure_try_lock ()
     ) <"$_lock"
 }
 
+ctdb_reconfigure_release_lock ()
+{
+    _ctdb_service_reconfigure_common
+    _lock="${_d}/reconfigure_lock"
+
+    rm -f "$_lock"
+}
+
 ctdb_replay_monitor_status ()
 {
     echo "Replaying previous status for this script due to reconfigure..."
-    # Leading colon (':') is missing in some versions...
-    _out=$(ctdb scriptstatus -Y | grep -E "^:?monitor:${script_name}:")
+    # Leading separator ('|') is missing in some versions...
+    _out=$(ctdb scriptstatus -X | grep -E "^\|?monitor\|${script_name}\|")
     # Output looks like this:
-    # :monitor:60.nfs:1:ERROR:1314764004.030861:1314764004.035514:foo bar:
+    # |monitor|60.nfs|1|ERROR|1314764004.030861|1314764004.035514|foo bar|
     # This is the cheapest way of getting fields in the middle.
-    set -- $(IFS=":" ; echo $_out)
+    set -- $(IFS="|" ; echo $_out)
     _code="$3"
     _status="$4"
     # The error output field can include colons so we'll try to
     # preserve them.  The weak checking at the beginning tries to make
-    # this work for both broken (no leading ':') and fixed output.
-    _out="${_out%:}"
-    _err_out="${_out#*monitor:${script_name}:*:*:*:*:}"
+    # this work for both broken (no leading '|') and fixed output.
+    _out="${_out%|}"
+    _err_out="${_out#*monitor|${script_name}|*|*|*|*|}"
     case "$_status" in
        OK) : ;;  # Do nothing special.
        TIMEDOUT)
@@ -1258,7 +853,7 @@ ctdb_service_check_reconfigure ()
        *) return 0 ;;
     esac
 
-    if ctdb_reconfigure_try_lock ; then
+    if ctdb_reconfigure_take_lock ; then
        # No events covered by this function are running, so proceed
        # with gay abandon.
        case "$event_name" in
@@ -1271,17 +866,9 @@ ctdb_service_check_reconfigure ()
                    ctdb_service_reconfigure
                fi
                ;;
-           monitor)
-               if ctdb_service_needs_reconfigure ; then
-                   ctdb_service_reconfigure
-                   # Given that the reconfigure might not have
-                   # resulted in the service being stable yet, we
-                   # replay the previous status since that's the best
-                   # information we have.
-                   ctdb_replay_monitor_status
-               fi
-               ;;
        esac
+
+       ctdb_reconfigure_release_lock
     else
        # Somebody else is running an event we don't want to collide
        # with.  We proceed with caution.
@@ -1337,14 +924,12 @@ is_ctdb_managed_service ()
     # backward compatibility and try again.
     ctdb_compat_managed_service "$CTDB_MANAGES_VSFTPD"   "vsftpd"
     ctdb_compat_managed_service "$CTDB_MANAGES_SAMBA"    "samba"
-    ctdb_compat_managed_service "$CTDB_MANAGES_SCP"      "scp"
     ctdb_compat_managed_service "$CTDB_MANAGES_WINBIND"  "winbind"
     ctdb_compat_managed_service "$CTDB_MANAGES_HTTPD"    "apache2"
     ctdb_compat_managed_service "$CTDB_MANAGES_HTTPD"    "httpd"
     ctdb_compat_managed_service "$CTDB_MANAGES_ISCSI"    "iscsi"
     ctdb_compat_managed_service "$CTDB_MANAGES_CLAMD"    "clamd"
     ctdb_compat_managed_service "$CTDB_MANAGES_NFS"      "nfs"
-    ctdb_compat_managed_service "$CTDB_MANAGES_NFS"      "nfs-ganesha-gpfs"
 
     t=" $CTDB_MANAGED_SERVICES "
 
@@ -1421,14 +1006,7 @@ ctdb_service_stop ()
 
 # Default service_start() and service_stop() functions.
  
-# These may be overridden in an eventscript.  When overriding, the
-# following convention must be followed.  If these functions are
-# called with no arguments then they may use internal logic to
-# determine whether the service is managed and, therefore, whether
-# they should take any action.  However, if the service name is
-# specified as an argument then an attempt must be made to start or
-# stop the service.  This is because the auto-start/stop code calls
-# them with the service name as an argument.
+# These may be overridden in an eventscript.
 service_start ()
 {
     service "$service_name" start
@@ -1443,27 +1021,24 @@ service_stop ()
 
 ctdb_standard_event_handler ()
 {
-    case "$1" in
-       status)
-           ctdb_checkstatus
-           exit
-           ;;
-       setstatus)
-            shift
-           ctdb_setstatus "$@"
-           exit
-           ;;
-    esac
+    :
 }
 
-# iptables doesn't like being re-entered, so flock-wrap it.
-iptables()
+iptables_wrapper ()
 {
-       flock -w 30 $CTDB_VARDIR/iptables-ctdb.flock /sbin/iptables "$@"
+    _family="$1" ; shift
+    if [ "$_family" = "inet6" ] ; then
+       _iptables_cmd="ip6tables"
+    else
+       _iptables_cmd="iptables"
+    fi
+
+    # iptables doesn't like being re-entered, so flock-wrap it.
+    flock -w 30 "${CTDB_SCRIPT_VARDIR}/iptables.flock" "$_iptables_cmd" "$@"
 }
 
 # AIX (and perhaps others?) doesn't have mktemp
-if ! which mktemp >/dev/null 2>&1 ; then
+if ! type mktemp >/dev/null 2>&1 ; then
     mktemp ()
     {
        _dir=false
@@ -1496,21 +1071,19 @@ update_tickles ()
 {
        _port="$1"
 
-       tickledir="$CTDB_VARDIR/state/tickles"
+       tickledir="${CTDB_SCRIPT_VARDIR}/tickles"
        mkdir -p "$tickledir"
 
-       # Who am I?
-       _pnn=$(ctdb pnn) ; _pnn=${_pnn#PNN:}
+       ctdb_get_pnn
 
        # What public IPs do I hold?
-       _ips=$(ctdb -Y ip | awk -F: -v pnn=$_pnn '$3 == pnn {print $2}')
+       _ips=$(ctdb -X ip | awk -F'|' -v pnn=$pnn '$3 == pnn {print $2}')
 
        # IPs as a regexp choice
        _ipschoice="($(echo $_ips | sed -e 's/ /|/g' -e 's/\./\\\\./g'))"
 
        # Record connections to our public IPs in a temporary file
        _my_connections="${tickledir}/${_port}.connections"
-       rm -f "$_my_connections"
        netstat -tn |
        awk -v destpat="^${_ipschoice}:${_port}\$" \
          '$1 == "tcp" && $6 == "ESTABLISHED" && $4 ~ destpat {print $5, $4}' |
@@ -1518,10 +1091,9 @@ update_tickles ()
 
        # Record our current tickles in a temporary file
        _my_tickles="${tickledir}/${_port}.tickles"
-       rm -f "$_my_tickles"
        for _i in $_ips ; do
-               ctdb -Y gettickles $_i $_port | 
-               awk -F: 'NR > 1 { printf "%s:%s %s:%s\n", $2, $3, $4, $5 }'
+               ctdb -X gettickles $_i $_port |
+               awk -F'|' 'NR > 1 { printf "%s:%s %s:%s\n", $2, $3, $4, $5 }'
        done |
        sort >"$_my_tickles"